CC = gcc
FLAGS = -O -DBUCKET
FLAGS1 = $(FLAGS) -c
CLIB = -ll -lm

OBJECTS = geom.o tab.o queue.o bfs.o nongreedy_stats.o output_gp.o greedy_history.o lex.yy.o kl.o backtrack.o etime.o adjlist.o postproc.o sort.o read.o textplot.o args.o bucket.o local_opt.o push_history.o bk.o

bk : $(OBJECTS) part.h;
	$(CC)  $(FLAGS) -o bk $(OBJECTS) $(CLIB)

geom.o : geom.c part.h ;
	$(CC) $(FLAGS1)     geom.c 

tab.o : tab.c part.h ;
	$(CC) $(FLAGS1)     tab.c 

queue.o : queue.c part.h ;
	$(CC) $(FLAGS1)     queue.c 

bfs.o : bfs.c part.h ;
	$(CC) $(FLAGS1)     bfs.c 

nongreedy_stats.o : nongreedy_stats.c part.h ;
	$(CC) $(FLAGS1)     nongreedy_stats.c 

output_gp.o : output_gp.c part.h ;
	$(CC) $(FLAGS1)     output_gp.c 

greedy_history.o : greedy_history.c part.h
	$(CC) $(FLAGS1)	greedy_history.c 

push_history.o : push_history.c part.h
	$(CC) $(FLAGS1)	push_history.c 

lex.yy.c : lex.l part.h;
	lex lex.l

lex.yy.o : lex.l lex.yy.c part.h;
	$(CC) $(FLAGS1)    lex.yy.c 

local_opt.o : local_opt.c part.h;
	$(CC) $(FLAGS1)    local_opt.c 

etime.o : etime.c part.h ;
	$(CC) $(FLAGS1)    etime.c 

adjlist.o : adjlist.c part.h ;
	$(CC) $(FLAGS1)    adjlist.c 

postproc.o : postproc.c part.h;
	$(CC) $(FLAGS1)    postproc.c 

sort.o : sort.c part.h;
	$(CC) $(FLAGS1)    sort.c 

textplot.o : textplot.c part.h;
	$(CC) $(FLAGS1)    textplot.c 

read.o : read.c part.h;
	$(CC) $(FLAGS1)    read.c 

args.o : args.c part.h;
	$(CC) $(FLAGS1)    args.c 

backtrack.o : backtrack.c backtrack.h
	$(CC) $(FLAGS1)    backtrack.c 

bk.o : bk.c backtrack.h
	$(CC) $(FLAGS1)    bk.c 

kl.o : kl.c backtrack.h part.h
	$(CC) $(FLAGS1)    kl.c 

bucket.o : bucket.c part.h
	$(CC) $(FLAGS1)    bucket.c 
