#include <stdio.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include "part.h"
#include "data_sets.h"

extern double Cluster_Definition;

int Cluster_Graph_Count;
int Cluster_Starts[MAX_VERTS];
int Cluster_Lengths[MAX_VERTS];
FILE *cfp;

void init_clusters()
{
	int j;

	Cluster_Graph_Count = 0;
	for (j=0; j<MAX_VERTS; j++) {
		Cluster_Starts[j] = 0;
		Cluster_Lengths[j] = 0;
	}
}

void read_clusters()
{
        extern int Regular_Graphs;
        extern int Reg_Degree;
        extern int Reg_Degree2;
        extern int Unbalanced_Regular_Graphs;
        extern int Unbalanced_Random_Graphs;
        extern int Geometric_Graphs;
        extern int num;
	extern double prob, prob2;
	extern FILE *outfile;

	int i, j;
	char fname[80], pr[30], *home, subdir[30];

        home=(char *)malloc(80);
        /*******************************************************************/
        /** for this code to work, V must be a multiple of 100            **/
        /*******************************************************************/
        if (Regular_Graphs) {
                sprintf(pr, "%d", Reg_Degree);
        } else if (Unbalanced_Regular_Graphs) {
                sprintf(pr, "%d.%d", Reg_Degree, Reg_Degree2);
        } else if (Unbalanced_Random_Graphs) {
                sprintf(pr, "%.3f.%.3f", prob, prob2);
        } else if (Geometric_Graphs) {
                sprintf(pr, "%.3f.G", prob);
        } else
                sprintf(pr, "%.3f", prob);
        home = getenv("HOME");
        strcpy(subdir, "/greedy/clusters/");

        sprintf(fname,"%s%scluster.%d.%s",home,subdir,num,pr);

	if ((cfp = fopen(fname, "r+")) != NULL) {
			fscanf(cfp," %d", &Cluster_Graph_Count);
			for (j=0; j<num; j++) {
				fscanf(cfp, "%d %d %d", &i ,
					&Cluster_Starts[j],
					&Cluster_Lengths[j]);
			}
	} else if ((cfp = fopen(fname, "w")) == NULL) 
			fprintf(outfile,"Error in %s file\n",fname), exit(9);
	rewind(cfp);
}

void update_clusters(int *post_tots)
				/* called from nongreedy_stats() after */
{				/* each graph is completed.	       */
	extern STATS_ARRAY_PTR Var_Stats;
	extern int num;
	int i=0, j=0;
	int last_ave_index = 0;
	int last_act_index = 0;
	int act_interval = 0;
	int ave_interval = 0;
	int curr_ng_count = 0;
	int curr_cluster = 0;
	int cluster_loc = 0;
	int next_val=0;

	Cluster_Graph_Count++;
	while ( (i<num) && (j<num) ) {
		while ((i++<num) && (next_val==curr_ng_count))
			next_val = (int) Var_Stats[0][i].mean;
		curr_ng_count++;
		ave_interval = i - last_ave_index;
		while ( (j<num) && (post_tots[j++] >= 0));
		act_interval = j - last_act_index;
		
		if (act_interval <  (Cluster_Definition * ave_interval)) {
			if (curr_cluster == 0) {
				curr_cluster = 1;
				cluster_loc = j;
			} else
				curr_cluster++;
		} else if (curr_cluster > 0) {
			Cluster_Starts[cluster_loc]++;
			Cluster_Lengths[cluster_loc] += curr_cluster;
			curr_cluster = 0;
		}
		last_ave_index = i;
		last_act_index = j;
	}
}

void write_clusters(int num_v)
{
	int j;
	double count, mean_starts, mean_length; 
	extern FILE *cfp;

	fprintf(cfp," %d\n", Cluster_Graph_Count);
	for (j=0; j<num_v; j++) {
		fprintf(cfp, "%d %d %d\n", j, 
			Cluster_Starts[j],
			Cluster_Lengths[j]);
	}
	fprintf(cfp, "AVE DATA:\n");
	fprintf(cfp, "---------\n");
	count = (double) Cluster_Graph_Count;
	for (j=0; j<num_v; j++) {
		mean_starts = Cluster_Starts[j] / count;
		if (Cluster_Starts[j] > 0)
		   mean_length=(double)Cluster_Lengths[j]/Cluster_Starts[j];
		else
		   mean_length = 0.0;
		fprintf(cfp, "%d %f %f\n", j, mean_starts, mean_length);
	}
	fflush(cfp);
	rewind(cfp);
}
