#ifndef DATA_SETS_H
#define DATA_SETS_H
#include<stdio.h>

#define NUM_DATA_SETS 4

#define NG_COUNT 	0
#define TOT_COST 	1
#define SIZE_A 		2
#define SIZE_B 		3

typedef struct {			/** for the PG algorithm **/
	double mean, std_dev;
} STAT_INFO, *STAT_INFOPTR;

typedef STAT_INFO (*STATS_ARRAY_PTR)[MAX_VERTICES];	/** ptr to 2d array **/
							/** of STAT_INFO    **/

typedef struct {		/* used for finding variance of a stat. */
	FILE *fp;		/* in KL postprocessing			*/
	int graph_count;
	double total[MAX_VERTICES];
	double sqr_total[MAX_VERTICES];
	int *data;
} DATA_SET, *DATA_SETPTR;


typedef struct {			/** for the PG algorithm **/
	double std_dev_mult;
	int reverse;			/** flag - reverse or not **/
					/** (fail if current val  **/
					/** is *outside* of       **/
					/** <std_dev_mults> of mean*/
					/** or not.		  **/
} VG_PARM, *VG_PARMPTR;
#endif
