/***********************************************************/
/*                  Graph Paritioning                      */
/*                       etime.c                           */
/*                                                         */
/*                Author:  James P. Fox                    */
/*                Advisor: Mark Goldberg                   */
/*                                                         */
/*                    Masters Project                      */
/*            Rensselaer Polytechnic Institute             */
/*                  Summer, Fall, 1990                     */
/***********************************************************/
/*     This module provides the routines to compute the    */
/*  elapsed time between two points.   Each time this      */
/*  routine is called it returns the elapsed time in       */
/*  CPU use seconds since the last call.                   */
/***********************************************************/

#include <sys/time.h>
#include <sys/resource.h>

int getrusage(int, struct rusage *);

struct rusage orusage ;

/***********************************************/
/************  log elapsed time  ***************/
/***********************************************/
double log_time() {  /** return elapsed seconds since last call **/
   struct rusage rusage ;
   double etime1,etime2, ttime ;
   getrusage(RUSAGE_SELF,&rusage) ;
   etime1 = (rusage.ru_utime.tv_sec - orusage.ru_utime.tv_sec) +
            (rusage.ru_utime.tv_usec - orusage.ru_utime.tv_usec) / 1000000.0 ;
   etime2 = (rusage.ru_stime.tv_sec - orusage.ru_stime.tv_sec) +
	    (rusage.ru_stime.tv_usec - orusage.ru_stime.tv_usec) / 1000000.0 ;
   ttime = etime1+etime2;
   getrusage(RUSAGE_SELF,&orusage);
   return(ttime);
}
