CC = gcc
#CFLAGS = -O -DBUCKET -DKL -ansi -pedantic -Wall
#CFLAGS = -O -DBUCKET -DKL -DCC_COMPILER
#CFLAGS = -g -DBUCKET -DKL -DCC_COMPILER

CFLAGS = -O -g -DBUCKET -DKL -ansi -pedantic -Wall
#CFLAGS = -g -DBUCKET -DKL -ansi -pedantic -Wall

#CFLAGS = -g -DBUCKET -DKL
#CFLAGS = -DBUCKET -DKL
CFLAGS1 = $(CFLAGS) -c
CLIBS = -lc -ll -lm

#old
#CC = gcc
#CFLAGS = -O -DBUCKET -DKL
#CFLAGS = -g -DBUCKET -DKL
#CFLAGS = -DBUCKET -DKL
#CFLAGS1 = $(CFLAGS) -c
#CLIBS = -ll -lm
#

OBJECTS = read_graph.o output_rao.o output_chaco.o output_gw.o sa.o find_prob.o sng_dist.o clusters.o var_tab.o var_tab2.o var_tab3.o var_tab4.o get_stats_rand.o get_stats_geom.o variance_stats.o data_sets.o regular.o kd_tab.o ng_uptab.o extra_files.o geom.o queue.o bfs.o nongreedy_stats.o output_gp.o greedy_history.o kl_main.o lex.yy.o kl.o backtrack.o etime.o adjlist.o postproc.o sort.o read.o textplot.o args.o bucket.o local_opt.o push_history.o

$(BINDIR)/kl: $(OBJECTS) part.h;
	c++  -v $(CFLAGS) -o $(BINDIR)/kl $(OBJECTS) $(CLIBS)

lex.yy.c : lex.l part.h;
	lex lex.l

lex.yy.o : lex.yy.c part.h;
	$(CC) $(CFLAGS1)     lex.yy.c 

read_graph.o : read_graph.c part.h read_graph.h;
	$(CC) $(CFLAGS1)     read_graph.c 

output_rao.o : output_rao.c part.h;
	$(CC) $(CFLAGS1)     output_rao.c 

output_chaco.o : output_chaco.c part.h;
	$(CC) $(CFLAGS1)     output_chaco.c 

output_gw.o : output_gw.c part.h;
	$(CC) $(CFLAGS1)     output_gw.c 

sa.o : sa.c part.h;
	$(CC) $(CFLAGS1)     sa.c 

find_prob.o : find_prob.c part.h;
	$(CC) $(CFLAGS1)     find_prob.c 

sng_dist.o : sng_dist.c part.h;
	$(CC) $(CFLAGS1)     sng_dist.c 

get_stats_geom.o : get_stats_geom.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     get_stats_geom.c 

get_stats_rand.o : get_stats_rand.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     get_stats_rand.c 

var_tab.o : var_tab.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     var_tab.c 

var_tab2.o : var_tab2.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     var_tab2.c 

var_tab3.o : var_tab3.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     var_tab3.c 

var_tab4.o : var_tab4.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     var_tab4.c 

clusters.o : clusters.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     clusters.c 

variance_stats.o : variance_stats.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     variance_stats.c 

data_sets.o : data_sets.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     data_sets.c 

regular.o : regular.c part.h ;
	$(CC) $(CFLAGS1)     regular.c 

kd_tab.o : kd_tab.c part.h ;
	$(CC) $(CFLAGS1)     kd_tab.c 

ng_uptab.o : ng_uptab.c part.h ;
	$(CC) $(CFLAGS1)     ng_uptab.c 

extra_files.o : extra_files.c part.h ;
	$(CC) $(CFLAGS1)     extra_files.c 

geom.o : geom.c part.h ;
	$(CC) $(CFLAGS1)     geom.c 

tab.o : tab.c part.h ;
	$(CC) $(CFLAGS1)     tab.c 

queue.o : queue.c part.h ;
	$(CC) $(CFLAGS1)     queue.c 

bfs.o : bfs.c part.h ;
	$(CC) $(CFLAGS1)     bfs.c 

nongreedy_stats.o : nongreedy_stats.c part.h ;
	$(CC) $(CFLAGS1)     nongreedy_stats.c 

output_gp.o : output_gp.c part.h ;
	$(CC) $(CFLAGS1)     output_gp.c 

greedy_history.o : greedy_history.c part.h ;
	$(CC) $(CFLAGS1)     greedy_history.c 

local_opt.o : local_opt.c part.h ;
	$(CC) $(CFLAGS1)     local_opt.c 

kl_main.o : kl_main.c part.h ;
	$(CC) $(CFLAGS1)     kl_main.c 

kl.o : kl.c part.h ;
	$(CC) $(CFLAGS1)     kl.c 

backtrack.o : backtrack.c backtrack.h data_sets.h;
	$(CC) $(CFLAGS1)     backtrack.c 

etime.o : etime.c part.h ;
	$(CC) $(CFLAGS1)     etime.c 

adjlist.o : adjlist.c part.h read_graph.h ;
	$(CC) $(CFLAGS1)     adjlist.c 

postproc.o : postproc.c part.h;
	$(CC) $(CFLAGS1)     postproc.c 

sort.o : sort.c part.h;
	$(CC) $(CFLAGS1)     sort.c 

textplot.o : textplot.c part.h;
	$(CC) $(CFLAGS1)     textplot.c 

read.o : read.c part.h data_sets.h;
	$(CC) $(CFLAGS1)     read.c 

args.o : args.c part.h;
	$(CC) $(CFLAGS1)     args.c 

bucket.o : bucket.c part.h;
	$(CC) $(CFLAGS1)     bucket.c 

push_history.o : push_history.c part.h;
	$(CC) $(CFLAGS1)     push_history.c 

