#include <stdio.h>
#include "part.h"

#define MAX_POOLS	100

extern int num;

static int usedptr;
static int push_count;
static int push_alloc;
static PUSHLISTPTR *push_history;
static PUSHLISTPTR *used;
static PUSHLISTPTR dummies;    
static PUSHLISTPTR push_pool;    

void update_push_history(int node, int side)
{
	PUSHLISTPTR  temp;

	if (push_count == push_alloc) {
		if (usedptr >= MAX_POOLS)
			printf("push_history: out of space\n"), exit(5);
		used[usedptr++] = push_pool;
		push_pool = (PUSHLISTPTR) calloc(push_alloc, sizeof(PUSHLIST));
		push_count = 0;
	}
	temp = &push_pool[push_count++];
	temp->side = side;
	temp->next = push_history[node]->next;
	push_history[node]->next = temp;
}

void init_push_history()
{
	int i;

	push_alloc = 2 *num;
	push_history = (PUSHLISTPTR *) calloc(num, sizeof(PUSHLISTPTR));
	dummies = (PUSHLISTPTR) calloc(num, sizeof(PUSHLIST));
	for (i=0; i<num; i++)
		push_history[i] = &dummies[i];
	usedptr = 0;
	used = (PUSHLISTPTR *) calloc(MAX_POOLS, sizeof(PUSHLISTPTR));
	push_pool = (PUSHLISTPTR) calloc(push_alloc, sizeof(PUSHLIST));
}

void free_push_history()
{
	int i;

	for (i=0; i<usedptr; i++)
		free((char *) used[i]);
	free((char *) push_pool);
	free((char *) dummies);
	free((char *) push_history);
	free((char *) used);
}

void print_push_history(int *vertices)
{
	int i, j, change, temp, repeat_count = 0, change_count=0;
	PUSHLISTPTR p, q;
	
	printf("-----------------------------------------------------------\n");
	printf("Repeat Candidates That Changed\n");
	printf("-----------------------------------------------------------\n");
	for (i=0; i<num; i++) {
		p = push_history[i];
		if (p->next && p->next->next) {
			repeat_count++;
			change = 0;
			temp = p->next->side;
			for (q = p->next; q; q = q->next) {
				if (q->side != temp)	change = 1;
				temp = q->side;
			}
			if (change) {
				change_count++;
				printf("%3d: ", i);
				for (q = p->next; q; q = q->next)
					printf("%-2d", q->side);
				for (j=0; j<num; j++)
					if (vertices[j] == i) {
						printf(" (placed %d of %d)"
							,j,num);
						break;	
					}
				printf("\n");
			}
		}
	}
	printf("Total changed repeat cands/Total repeat cands:(%d,%d)\n", 
						change_count, repeat_count);
	printf("-----------------------------------------------------------\n");
}
/*
main()
{
	int i, j, k;
	char *str = (char *) malloc(80);
	char op[10];
	LISTPTR node;

while(1) {
	fgets(str, 80, stdin);
	sscanf(str, " %d \n", &num);
	
	init_push_history();

	while (num >= 0) {
		fgets(str, 80, stdin);
		sscanf(str, "%s %d %d \n", op, &i, &j);
		switch (op[0]) {
			case 'u' : update_push_history(i, j);
				   break;
			case 'c' : num = -1; break;
			case 'q' : exit();
		}
		print_push_history();
	}
	free_push_history();
}
}
*/
