/***********************************************************/
/*                  Graph Paritioning                      */
/*                      textplot.c                         */
/*                                                         */
/*                Author:  James P. Fox                    */
/*                Advisor: Mark Goldberg                   */
/*                                                         */
/*                    Masters Project                      */
/*            Rensselaer Polytechnic Institute             */
/*                  Summer, Fall, 1990                     */
/***********************************************************/
/*     This module takes as input an array of integer      */
/*  and produces a plot of the values in text mode.  Since */
/*  we are limited by the screen/printer in horizontal     */
/*  resolution to the constant "MAX_GRAPH_WIDTH", adjacent */
/*  data items are averaged to compute the plotted point   */
/***********************************************************/

#include <ctype.h>
#include <stdio.h>
#include "part.h"

/****** NOTE 2/21/93  - <values> is fed by hold_post_tots. ******/
/****** Jim had that indexed by vertex number.  I changed  ******/
/****** it to vertex rank.  I have no idea how it will 	   ******/
/****** affect this function, which I never use.   JWB     ******/

/******************************************************/
/*****************   print graphics   *****************/
/******************************************************/
void print_text_graph(
int *values,int numvalues,
char *pos_label, char *neg_label,
FILE *outf, 
int cum) /** do cumulative averages **/
{  register i,j;
   int high, low,pp;
   int cumavg, cumnum;
   int graph_avg[MAX_GRAPH_WIDTH+1];
   int graph_num[MAX_GRAPH_WIDTH+1];
   for(i=0;i<MAX_GRAPH_WIDTH+1;i++) {
      graph_avg[i] = 0;
      graph_num[i] = 0;
    }
   for(i=0;i<numvalues;i++) {
      pp = ((i*MAX_GRAPH_WIDTH)-1)/numvalues;
      graph_avg[pp] = graph_avg[pp] + values[i];
      graph_num[pp]++;
    }

   if(cum) {
      cumnum = 0 ;
      cumavg = 0 ;
      for(i=0;i<MAX_GRAPH_WIDTH;i++) {
         graph_avg[i] += cumavg;
         graph_num[i] += cumnum;
         cumavg = graph_avg[i];
         cumnum = graph_num[i];
       }
    }

   low = VERY_HIGH;
   high = VERY_LOW;
   for(i=0;i<MAX_GRAPH_WIDTH;i++) {
      if(graph_num[i] > 0)
	 graph_avg[i] = graph_avg[i]/graph_num[i];
      if(graph_avg[i] > high)
	 high = graph_avg[i];
      if(graph_avg[i] < low)
	 low = graph_avg[i];
    }
   if(high < 2)
      high = 2;
   if(high > MAX_GRAPH_HEIGHT)
      high = MAX_GRAPH_HEIGHT;
   if(low > -2)
      low = -2;
   if(-low > MAX_GRAPH_HEIGHT)
      low = (-MAX_GRAPH_HEIGHT);


   fprintf(outf,"%s\n",pos_label);
   for(i=high;i>=low;i--) {
      if(i==0)
	 fprintf(outf,"---0-|");
      else
	 fprintf(outf," %3d |",i);
      for(j=0;j<MAX_GRAPH_WIDTH;j++) {
	 if(graph_avg[j]==i)
	    fprintf(outf,"*");
	 else
	    if(i == 0)
	       fprintf(outf,"-");
	    else
	       fprintf(outf," ");
       }
     fprintf(outf,"\n");
    }
   fprintf(outf,"%s\n",neg_label);
 }
