#include "part.h"
#include "data_sets.h"

STATS_ARRAY_PTR Var_Stats;	/* this is set in read.c (which calls */
				/* get_stats_rand(), etc.)            */

int variance_stats_ok(int *current_stats, int pos)
{
	extern VG_PARM Data_Sets[NUM_DATA_SETS];
	VG_PARMPTR dsptr;
	int i;
	double c, sd, mn;
	STAT_INFOPTR sp;

	if (pos <= 10)
		return(PASS);
	
	i=0;
	for (i=0; i<NUM_DATA_SETS; i++) {
		dsptr = &Data_Sets[i];
		if (dsptr->reverse < 0) continue;   /* neg for non-checked stats */
		sp = &Var_Stats[i][pos];
		c = (double) current_stats[i];
		mn = sp->mean;
		sd = (dsptr->std_dev_mult) * sp->std_dev;
		if (dsptr->reverse) {
			if ( ((c >= (mn - sd)) && (c <= (mn + sd)))  )  {
				return(FAIL);
			}
		} else {
			if (! ((c >= (mn - sd)) && (c <= (mn + sd)))  )  {
				return(FAIL);
			}
		}
	}
	return(PASS);
}

int stats_say_ng_step(int ng_count, int pos)
{
	extern VG_PARM Data_Sets[NUM_DATA_SETS];
	VG_PARMPTR dsptr;
	double c, sd, mn;
	STAT_INFOPTR sp, sp_old;

	dsptr = &Data_Sets[NG_COUNT];
	sp = &Var_Stats[NG_COUNT][pos];
	if (pos > 0)
		sp_old = &Var_Stats[NG_COUNT][pos-1];
	else
		sp_old = sp;
	c = (double) ng_count;
	mn = sp->mean;
	sd = (dsptr->std_dev_mult) * sp->std_dev;
	if ( (c < (mn - sd)) || ( (int) mn - (int) sp_old->mean) )
		return(TRUE);
	else
		return(FALSE);
}

/* used to be double */
double find_next_ng_prob(int ng_count, int pos)
{
	extern int P_Prob;			/* which ng_distrib to use */
	extern int P_Interval;
	extern PG_DIST (*ng_distrib)[DISTRIB_SIZE];
	extern VG_PARM Data_Sets[NUM_DATA_SETS];

	VG_PARMPTR dsptr;
	int index = (pos / P_Interval);
	double c, sd, mn;
	double std_pct_diff;
	double this_pct_diff;
	double sd_factor;
	double next_ng_prob;
	STAT_INFOPTR sp;

	dsptr = &Data_Sets[NG_COUNT];
	sp = &Var_Stats[NG_COUNT][pos];
	c = (double) ng_count;
	mn = sp->mean;
	sd = sp->std_dev;

	/*next_ng_prob = ng_distrib[0][pos-1].d[0];*/
	next_ng_prob = ng_distrib[P_Prob][index].d[0];

	std_pct_diff = sd / mn;
	/*this_pct_diff = ABS(mn - ng_count) / mn;*/
	this_pct_diff = (mn >= ng_count) ? (mn - ng_count) / ng_count
					 : -((ng_count - mn) / mn);
	sd_factor = ABS(this_pct_diff) / std_pct_diff;

	/* dsptr->std_dev_mult currently unused */

	/*next_ng_prob = next_ng_prob +  (this_pct_diff * next_ng_prob);*/
	next_ng_prob = next_ng_prob +  
			 (this_pct_diff * next_ng_prob * sd_factor);
	return next_ng_prob;
}
